
from xdxsmi.api.pyxdxml import *
import time

def deviceQuery():
    strResult = ''
    #
    # Initialize NVML
    #
    xdxml_init()

    deviceCount = xdxml_device_get_count()
    strResult += '<attached_gpus>' + str(deviceCount) + '</attached_gpus>\n'

    for i in range(0, deviceCount):
        handle = xdxml_device_get_handle_by_index(i)

        device_name = xdxml_device_get_name(handle)
        strResult += '  <product_name>' + device_name.decode('utf-8') + '</product_name>\n'

        pciInfo = xdxml_device_get_pci_info(handle)
        strResult += '  <pci_domain="%s">\n' % pciInfo.domain
        strResult += '  <pci_bus="%s">\n' % pciInfo.bus
        strResult += '  <pci_device="%s">\n' % pciInfo.device
        strResult += '  <pci_func="%s">\n' % pciInfo.func
        strResult += '  <pci_dbdf="%s">\n' % pciInfo.pci_dbdf

        clkInfo = xdxml_device_get_clock(handle)
        strResult += '  <clk_gfx="%s">\n' % clkInfo.xdx_gfx_freq
        strResult += '  <clk_gddr="%s">\n' % clkInfo.xdx_gddr_phys_freq
        strResult += '  <clk_acpu="%s">\n' % clkInfo.xdx_acpu_freq
        strResult += '  <clk_ndf="%s">\n' % clkInfo.xdx_ndf_freq
        strResult += '  <clk_cmcu="%s">\n' % clkInfo.xdx_cmcu_freq

        curr_link_width = xdxml_device_get_curr_pcie_link_width(handle)
        max_link_width = xdxml_device_get_max_pcie_link_width(handle)
        curr_link_speed = xdxml_device_get_pcie_speed(handle)
        max_link_speed = xdxml_device_get_pcie_link_max_speed(handle)
        curr_link_gen = xdxml_device_get_curr_pcie_link_generation(handle)
        max_link_gen = xdxml_device_get_max_pcie_link_generation(handle)
        strResult += '  <pcie_curr_link_width="%s">\n' % curr_link_width       
        strResult += '  <max_link_width="%s">\n' % max_link_width      
        strResult += '  <curr_link_speed="%s">\n' % curr_link_speed
        strResult += '  <max_link_speed="%s">\n' % max_link_speed
        strResult += '  <curr_link_gen="%s">\n' % curr_link_gen
        strResult += '  <max_link_gen="%s">\n' % max_link_gen

        fan_speed = xdxml_device_get_fan_speed(handle)
        fan_min_max_speed = xdxml_device_get_min_max_fan_speed(handle)
        fan_pwm = xdxml_device_get_fan_pwm(handle)
        fan_pwm_min = xdxml_device_get_pwm_min(handle)
        fan_pwm_max = xdxml_device_get_pwm_max(handle)
        strResult += '  <fan_speed="%s">\n' % fan_speed
        strResult += '  <fan_min_speed="%s">\n' % fan_min_max_speed["min_fan_speed"]
        strResult += '  <fan_max_speed="%s">\n' % fan_min_max_speed["max_fan_speed"]
        strResult += '  <fan_pwm="%s">\n' % fan_pwm
        strResult += '  <fan_pwm_min="%s">\n' % fan_pwm_min
        strResult += '  <fan_pwm_max="%s">\n' % fan_pwm_max

        pwrInfo = xdxml_device_get_power_info(handle)
        strResult += '  <volt="%.1f">\n' % pwrInfo.volt
        strResult += '  <current="%.3f">\n' % pwrInfo.current
        strResult += '  <pwr="%.3f">\n' % pwrInfo.pwr
        strResult += '  <power_cap="%d">\n' % pwrInfo.power_cap
        strResult += '  <power1_cap_max="%d">\n' % pwrInfo.power1_cap_max
        strResult += '  <power1_cap_min="%d">\n' % pwrInfo.power1_cap_min

        tempInfo = xdxml_device_get_temper_info(handle)
        strResult += '  <ctrl_mode="%s">\n' % tempInfo.ctrl_mode
        strResult += '  <temp="%s">\n' % tempInfo.temp
        strResult += '  <temp_highest="%s">\n' % tempInfo.temp_highest
        strResult += '  <temp_min="%s">\n' % tempInfo.temp_min
        strResult += '  <temp_max="%s">\n' % tempInfo.temp_max
        strResult += '  <temp_crit="%s">\n' % tempInfo.temp_crit

        dspModep = xdxml_device_get_display_status(handle)
        strResult += '  <display="%d">\n' % dspModep

        memInfo = xdxml_device_get_mem_info(handle)
        strResult += '  <fb_free="%ld">\n' % memInfo.fb_free
        strResult += '  <fb_free="%ld">\n' % memInfo.fb_total
        strResult += '  <fb_free="%ld">\n' % memInfo.fb_used
        strResult += '  <sys_free="%ld">\n' % memInfo.sys_free
        strResult += '  <sys_total="%ld">\n' % memInfo.sys_total
        strResult += '  <sys_used="%ld">\n' % memInfo.sys_used       

        queryInfo = xdxml_device_query(handle)
        strResult += '  <dsp_mode="%s">\n' % queryInfo.display_status       
        strResult += '  <name="%s">\n' % queryInfo.name
        strResult += '  <uuid="%s">\n' % queryInfo.uuid
        strResult += '  <curr_pcie_link_width="%s">\n' % queryInfo.curr_pcie_link_width
        strResult += '  <primary_id="%s">\n' % queryInfo.primary_id
        strResult += '  <primary_core_id="%s">\n' % queryInfo.primary_core_id
        strResult += '  <asci_type="%s">\n' % queryInfo.asci_type
        strResult += '  <core="%d">\n' % queryInfo.core

        strResult += '  <err_corr="%s">\n' % queryInfo.err_corr
        strResult += '  <err_fatal="%s">\n' % queryInfo.err_fatal
        strResult += '  <non_fatal="%s">\n' % queryInfo.non_fatal

        strResult += '  <mmbar_type="%s">\n' % queryInfo.mmbar_type

        strResult += '  <pcie_event="%d">\n' % queryInfo.pcie_event
        strResult += '  <perst_assert="%d">\n' % queryInfo.perst_assert
        strResult += '  <perst_de_assert="%d">\n' % queryInfo.perst_de_assert
        strResult += '  <link_clk_stable="%d">\n' % queryInfo.link_clk_stable
        strResult += '  <link_down="%d">\n' % queryInfo.link_down
        strResult += '  <perst_assert_acpu_ack="%d">\n' % queryInfo.perst_assert_acpu_ack
        strResult += '  <perst_de_assert_acpu_ack="%d">\n' % queryInfo.perst_de_assert_acpu_ack
        strResult += '  <fw_ver="%s">\n' % queryInfo.fw_ver
        strResult += '  <gddr_count="%d">\n' % queryInfo.gddr_count

        strResult += '  <pci_dbdf="%s">\n' % queryInfo.pci_dbdf
        strResult += '  <fb_free="%ld">\n' % queryInfo.fb_free
        strResult += '  <fb_free="%ld">\n' % queryInfo.fb_total
        strResult += '  <fb_free="%ld">\n' % queryInfo.fb_used
        strResult += '  <sys_free="%ld">\n' % queryInfo.sys_free
        strResult += '  <sys_total="%ld">\n' % queryInfo.sys_total
        strResult += '  <sys_used="%ld">\n' % queryInfo.sys_used

        drvier_ver = xdxml_device_get_driver_version(handle)
        strResult += '  <DDK="%s">\n' % drvier_ver.DDK
        strResult += '  <KMD="%s">\n' % drvier_ver.KMD
        strResult += '  <UMD="%s">\n' % drvier_ver.UMD
    return strResult

# this is not exectued when module is imported
if __name__ == "__main__":
    #print("before set")
    print(deviceQuery())
    
    #set fuction
    # handle = xdxml_device_get_handle_by_index(0)
    # xdxml_device_set_fan_pwm1(handle, 2500)
    # xdxml_device_set_power_warn(handle, 200)
    # xdxml_device_set_gfx_clock(handle, 900)
    # xdxml_device_set_temper_info(handle, 80, "temp1_crit")

    # time.sleep(2)
    # print("after set")
    # print(deviceQuery())

