# -*- coding: utf-8 -*-

# from typing import Dict, Sequence, Callable, List, Tuple
from xdxsmi.api.smi import XdxSmi
from xdxsmi.cli.render import Render

from xdxsmi.api.xdxgpu import XdxGpu
from xdxsmi.api.pyxdxml import *
# from typing import Any
import sys

#Directories containing all target attributes
nodes = ["card", "hwmon"]

#Set values for attributes
# (xdx_smi: XdxSmi, args: Dict, target_ip: list, target_gpus: list, attrs_map: list)
def setAttrs(xdx_smi, args, target_ip, target_gpus, attrs_map):
    #Set value for the target attribute in nodes, "card" and "hwmon"

    #breakpoint()

    # xdx_smi.apply_on_gpus(
    #     xdx_smi.generate_attr_writer(nodes, \
    #         [attrs_map[k] for k in target_ip], args["<mhz>"]), target_gpus)
    c_lib_set(xdx_smi, [attrs_map[k] for k in target_ip], args["<mhz>"])


#zihan added for c_lib set
# c_set_attr(xdx_smi: XdxSmi, attr: str, newVal: Any)
def c_set_attr(xdx_smi, attr, newVal):
    #breakpoint()
    handle = xdx_smi.handle
    if attr == "xdx_gfx_freq_mhz":
        #print("enter c_set_attr to set xdx_gfx_freq_mhz " + newVal + " mhz")
        result = xdxml_device_set_gfx_clock(handle, newVal)
    if attr == "pwm1":
        #print("enter c_set_attr to set pwm1 " + newVal + " mhz")
        result = xdxml_device_set_fan_pwm1(handle, newVal)
    if attr == "fan1_ctrl_mode":
        result = xdxml_device_set_fan_ctrl_mode(handle, newVal)
    if attr == "fan1_target":
        result = xdxml_device_set_fan1_speed(handle, newVal)
    if (attr == "temp1_crit") or (attr == "temp1_min") or (attr == "temp1_max") or (attr == "temp1_ctrl_mode"):
        #print("zihan_debug enter c_set_attr to set temper " + attr + " " + newVal + "C")
        result = xdxml_device_set_temper_info(handle, newVal, attr)
    if attr == "in0_input":
        #print("enter c_set_attr to set volt " + newVal + " mhz")
        result = xdxml_device_set_power_volt(handle, newVal)
    if attr == "power1_cap":
        result = xdxml_device_set_power_warn(handle, newVal)
    return 0

#zihan added for c_lib
# (xdx_smi: XdxSmi, attrs: Sequence[str], newVal: Any)
def c_lib_set(xdx_smi, attrs, newVal):
    for attr in attrs:
        ret = c_set_attr(xdx_smi, attr, newVal)
    return ret

#zihan added for c_lib get
# (xdx_smi: XdxSmi,attr: str)
def c_get_attr(xdx_smi, attr):
    #zihan：TODO Every time an instruction is entered, the following several functions will be called again.
    #handle = xdxml_device_get_handle_by_index(0)
    #clkInfo = xdxml_device_get_clock(xdx_smi.handle)
    #powerInfo = xdxml_device_get_power_info(xdx_smi.handle)
    #tempInfo = xdxml_device_get_temper_info(xdx_smi.handle)

    #zihan：TODO if change to switch case
    if attr == "xdx_product_name":
        device_name = xdxml_device_get_name(xdx_smi.handle)
        return device_name.decode('utf-8')

    if attr == "xdx_dbdf":
        return "0000:01:00.0"

    if attr == "xdx_gfx_freq_mhz" or "xdx_gddr_phys_freq_mhz" or "xdx_acpu_freq_mhz" or "xdx_ndf_freq_mhz" or "xdx_cmcu_freq_mhz":
        clkInfo = xdxml_device_get_clock(xdx_smi.handle)
    if attr == "xdx_gfx_freq_mhz":
        return str(clkInfo.xdx_gfx_freq)+"MHz"
    if attr == "xdx_gddr_phys_freq_mhz":
        return str(clkInfo.xdx_gddr_phys_freq)+"GHz"
    if attr == "xdx_acpu_freq_mhz":
        return str(round(clkInfo.xdx_acpu_freq,1))+"GHz"
    if attr == "xdx_ndf_freq_mhz":
        return str(round(clkInfo.xdx_ndf_freq,1))+"GHz"
    if attr == "xdx_cmcu_freq_mhz":
        return str(clkInfo.xdx_cmcu_freq)+"MHz"

    if attr == "pwm1":
        pwm1 = xdxml_device_get_fan_pwm(xdx_smi.handle)
        return str(pwm1)
    if attr == "pwm1_min":
        pwm1_min = xdxml_device_get_pwm_min(xdx_smi.handle)
        return str(pwm1_min)
    if attr ==  "pwm1_max":
        pwm1_max = xdxml_device_get_pwm_max(xdx_smi.handle)
        return str(pwm1_max)
    
    if attr == "in0_input" or "curr1_input" or  "power1_average":
        powerInfo = xdxml_device_get_power_info(xdx_smi.handle)
    if attr == "in0_input":
        return str(round(powerInfo.volt,1))+"V"
    if attr == "curr1_input":
        return str(round(powerInfo.current,3))+"A"
    if attr == "power1_average":
        return str(round(powerInfo.pwr,3))+"W"

    if attr == "temp1_input" or "temp1_highest" or  "temp1_ctrl_mode" or "temp1_min" or "temp1_max" or "temp1_crit":
        tempInfo = xdxml_device_get_temper_info(xdx_smi.handle)
    if attr == "temp1_input":
        return str(tempInfo.temp)+"°C"
    if attr == "temp1_highest":
        return str(tempInfo.temp_highest)+"°C"
    if attr == "temp1_ctrl_mode":
        return str(tempInfo.ctrl_mode)
    if attr == "temp1_min":
        return str(tempInfo.temp_min)+"°C"
    if attr == "temp1_max":
        return str(tempInfo.temp_max)+"°C"
    if attr == "temp1_crit":
        return str(tempInfo.temp_crit)+"°C"

# def c_get_attr(attr: str):
#     breakpoint()
#     #zihan: TODO change handle to a global variable, the function xdxml_device_get_handle_by_index will be called within xdxgpu.py.
#     handle = xdxml_device_get_handle_by_index(0)
#     clkInfo = xdxml_device_get_clock(handle)
#     powerInfo = xdxml_device_get_power_info(handle)
#     tempInfo = xdxml_device_get_temper_info(handle)
#     breakpoint()
#     match attr:
#         case "xdx_product_name":
#             device_name = xdxml_device_get_name(handle)
#             return device_name.decode('utf-8')
#         case "xdx_dbdf":
#             return "0000:01:00.0"

#         case "xdx_product_name":
#             device_name = xdxml_device_get_name(handle)
#             return device_name.decode('utf-8')

#         case "xdx_dbdf":
#             return "0000:01:00.0"

#         case "xdx_gfx_freq_mhz":
#             return str(clkInfo.xdx_gfx_freq)+"MHz"
#         case "xdx_gddr_phys_freq_mhz":
#             return str(clkInfo.xdx_gddr_phys_freq)+"GHz"
#         case "xdx_acpu_freq_mhz":
#             return str(round(clkInfo.xdx_acpu_freq,1))+"GHz"
#         case "xdx_ndf_freq_mhz":
#             return str(round(clkInfo.xdx_ndf_freq,1))+"GHz"
#         case "xdx_cmcu_freq_mhz":
#             return str(clkInfo.xdx_cmcu_freq)+"MHz"

#         case "pwm1":
#             pwm1 = xdxml_device_get_fan_pwm(handle)
#             return str(pwm1)
#         case "pwm1_min":
#             pwm1_min = xdxml_device_get_pwm_min(handle)
#             return str(pwm1_min)
#         case  "pwm1_max":
#             pwm1_max = xdxml_device_get_pwm_max(handle)
#             return str(pwm1_max)

#         case "in0_input":
#             return str(round(powerInfo.volt,1))+"V"
#         case "curr1_input":
#             return str(round(powerInfo.current,3))+"A"
#         case "power1_average":
#             return str(round(powerInfo.pwr,3))+"W"

#         case "temp1_input":
#             return str(tempInfo.temp)+"°C"
#         case "temp1_highest":
#             return str(tempInfo.temp_highest)+"°C"
#         case "temp1_ctrl_mode":
#             return str(tempInfo.ctrl_mode)
#         case "temp1_min":
#             return str(tempInfo.temp_min)+"°C"
#         case "temp1_max":
#             return str(tempInfo.temp_max)+"°C"
#         case "temp1_crit":
#             return str(tempInfo.temp_crit)+"°C"
       
#zihan added for c_lib
# (xdx_smi: XdxSmi, attrs: Sequence[str])
def c_lib_get(xdx_smi, attrs):
    res = []
    ret = []
    res.append("0")
    for attr in attrs:
        val = c_get_attr(xdx_smi,attr)
        res.append(str(val))
    ret.append(res)
    #breakpoint()
    return ret

#Get values from attributes
# (xdx_smi: XdxSmi, args: Dict, target_ip: list, target_gpus: list, attrs_map: list)
def getAttrs(xdx_smi, args, target_ip, target_gpus, attrs_map):
    #Filter user-entered wrong attributes
    input_ip = ["gpu", "name"] + list(args["<ip>"])
    if args["<ip>"]:
        target_ip = [ip for ip in target_ip if ip in input_ip]
    
    # #Get values of target attributes in nodes, "card" and "hwmon"
    # data = xdx_smi.apply_on_gpus(
    #             xdx_smi.generate_attr_reader(nodes,
    #                 [attrs_map[k] for k in target_ip]), target_gpus)

    #zihan added for c_lib
    data = c_lib_get(xdx_smi, [attrs_map[k] for k in target_ip])
    #breakpoint()
    
    #Add attribute names
    target_ip.insert(0, "Index")
    data.insert(0, list(target_ip))

    #Show data on screen
    Render.render_table(data, args)
