/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __DC_8200_H__
#define __DC_8200_H__

#include "dm_plane.h"
#include "dm_crtc.h"
#include "dm_fb.h"
#include "dec400.h"
#include "dm_dc.h"
#if LINUX_VERSION_CODE >= KERNEL_VERSION(6, 0, 0)
#include <drm/drm_blend.h>
#endif

#define AQ_INTR_ACKNOWLEDGE 0x0010
#define AQ_INTR_ENBL 0x0014
#define DC_HW_REVISION 0x0024
#define DC_HW_CHIP_CID 0x0030

#define DC_REG_BASE 0x0800
#define DC_REG_RANGE 0x2000
#define DC_SEC_REG_OFFSET 0x100000

#define DC_FRAMEBUFFER_CONFIG 0x1518
#define DC_FRAMEBUFFER_CONFIG_EX 0x1CC0
#define DC_FRAMEBUFFER_SCALE_CONFIG 0x1520
#define DC_FRAMEBUFFER_TOP_LEFT 0x24D8
#define DC_FRAMEBUFFER_BOTTOM_RIGHT 0x24E0
#define DC_FRAMEBUFFER_ADDRESS 0x1400
#define DC_FRAMEBUFFER_U_ADDRESS 0x1530
#define DC_FRAMEBUFFER_V_ADDRESS 0x1538
#define DC_FRAMEBUFFER_STRIDE 0x1408
#define DC_FRAMEBUFFER_U_STRIDE 0x1800
#define DC_FRAMEBUFFER_V_STRIDE 0x1808
#define DC_FRAMEBUFFER_SIZE 0x1810
#define DC_FRAMEBUFFER_SCALE_FACTOR_X 0x1828
#define DC_FRAMEBUFFER_SCALE_FACTOR_Y 0x1830
#define DC_FRAMEBUFFER_H_FILTER_COEF_INDEX 0x1838
#define DC_FRAMEBUFFER_H_FILTER_COEF_DATA 0x1A00
#define DC_FRAMEBUFFER_V_FILTER_COEF_INDEX 0x1A08
#define DC_FRAMEBUFFER_V_FILTER_COEF_DATA 0x1A10
#define DC_FRAMEBUFFER_INIT_OFFSET 0x1A20
#define DC_FRAMEBUFFER_COLOR_KEY 0x1508
#define DC_FRAMEBUFFER_COLOR_KEY_HIGH 0x1510
#define DC_FRAMEBUFFER_CLEAR_VALUE 0x1A18
#define DC_FRAMEBUFFER_COLOR_TABLE_INDEX 0x1818
#define DC_FRAMEBUFFER_COLOR_TABLE_DATA 0x1820
#define DC_FRAMEBUFFER_BG_COLOR 0x1528
#define DC_FRAMEBUFFER_ROI_ORIGIN 0x1CB0
#define DC_FRAMEBUFFER_ROI_SIZE 0x1CB8
#define DC_FRAMEBUFFER_WATER_MARK 0x1CE8
#define DC_FRAMEBUFFER_DEGAMMA_INDEX 0x1D88
#define DC_FRAMEBUFFER_DEGAMMA_DATA 0x1D90
#define DC_FRAMEBUFFER_DEGAMMA_EX_DATA 0x1D98
#define DC_FRAMEBUFFER_YUVTORGB_COEF0 0x1DA0
#define DC_FRAMEBUFFER_YUVTORGB_COEF1 0x1DA8
#define DC_FRAMEBUFFER_YUVTORGB_COEF2 0x1DB0
#define DC_FRAMEBUFFER_YUVTORGB_COEF3 0x1DB8
#define DC_FRAMEBUFFER_YUVTORGB_COEF4 0x1E00
#define DC_FRAMEBUFFER_YUVTORGB_COEFD0 0x1E08
#define DC_FRAMEBUFFER_YUVTORGB_COEFD1 0x1E10
#define DC_FRAMEBUFFER_YUVTORGB_COEFD2 0x1E18
#define DC_FRAMEBUFFER_Y_CLAMP_BOUND 0x1E88
#define DC_FRAMEBUFFER_UV_CLAMP_BOUND 0x1E90
#define DC_FRAMEBUFFER_RGBTORGB_COEF0 0x1E20
#define DC_FRAMEBUFFER_RGBTORGB_COEF1 0x1E28
#define DC_FRAMEBUFFER_RGBTORGB_COEF2 0x1E30
#define DC_FRAMEBUFFER_RGBTORGB_COEF3 0x1E38
#define DC_FRAMEBUFFER_RGBTORGB_COEF4 0x1E40
#define DC_FRAMEBUFFER_BLEND_CONFIG 0x2510
#define DC_FRAMEBUFFER_SRC_GLOBAL_COLOR 0x2500
#define DC_FRAMEBUFFER_DST_GLOBAL_COLOR 0x2508
#define DC_PANEL_STATE0 0X2520
#define DC_PANEL_STATE1 0X2524

#define DC_OVERLAY_CONFIG 0x1540
#define DC_OVERLAY_CONFIG_EX 0x2540
#define DC_OVERLAY_SCALE_CONFIG 0x1C00
#define DC_OVERLAY_BLEND_CONFIG 0x1580
#define DC_OVERLAY_TOP_LEFT 0x1640
#define DC_OVERLAY_BOTTOM_RIGHT 0x1680
#define DC_OVERLAY_ADDRESS 0x15C0
#define DC_OVERLAY_U_ADDRESS 0x1840
#define DC_OVERLAY_V_ADDRESS 0x1880
#define DC_OVERLAY_STRIDE 0x1600
#define DC_OVERLAY_U_STRIDE 0x18C0
#define DC_OVERLAY_V_STRIDE 0x1900
#define DC_OVERLAY_SIZE 0x17C0
#define DC_OVERLAY_SCALE_FACTOR_X 0x1A40
#define DC_OVERLAY_SCALE_FACTOR_Y 0x1A80
#define DC_OVERLAY_H_FILTER_COEF_INDEX 0x1AC0
#define DC_OVERLAY_H_FILTER_COEF_DATA 0x1B00
#define DC_OVERLAY_V_FILTER_COEF_INDEX 0x1B40
#define DC_OVERLAY_V_FILTER_COEF_DATA 0x1B80
#define DC_OVERLAY_INIT_OFFSET 0x1BC0
#define DC_OVERLAY_COLOR_KEY 0x1740
#define DC_OVERLAY_COLOR_KEY_HIGH 0x1780
#define DC_OVERLAY_CLEAR_VALUE 0x1940
#define DC_OVERLAY_COLOR_TABLE_INDEX 0x1980
#define DC_OVERLAY_COLOR_TABLE_DATA 0x19C0
#define DC_OVERLAY_SRC_GLOBAL_COLOR 0x16C0
#define DC_OVERLAY_DST_GLOBAL_COLOR 0x1700
#define DC_OVERLAY_ROI_ORIGIN 0x1D00
#define DC_OVERLAY_ROI_SIZE 0x1D40
#define DC_OVERLAY_WATER_MARK 0x1DC0
#define DC_OVERLAY_DEGAMMA_INDEX 0x2200
#define DC_OVERLAY_DEGAMMA_DATA 0x2240
#define DC_OVERLAY_DEGAMMA_EX_DATA 0x2280
#define DC_OVERLAY_YUVTORGB_COEF0 0x1EC0
#define DC_OVERLAY_YUVTORGB_COEF1 0x1F00
#define DC_OVERLAY_YUVTORGB_COEF2 0x1F40
#define DC_OVERLAY_YUVTORGB_COEF3 0x1F80
#define DC_OVERLAY_YUVTORGB_COEF4 0x1FC0
#define DC_OVERLAY_YUVTORGB_COEFD0 0x2000
#define DC_OVERLAY_YUVTORGB_COEFD1 0x2040
#define DC_OVERLAY_YUVTORGB_COEFD2 0x2080
#define DC_OVERLAY_Y_CLAMP_BOUND 0x22C0
#define DC_OVERLAY_UV_CLAMP_BOUND 0x2300
#define DC_OVERLAY_RGBTORGB_COEF0 0x20C0
#define DC_OVERLAY_RGBTORGB_COEF1 0x2100
#define DC_OVERLAY_RGBTORGB_COEF2 0x2140
#define DC_OVERLAY_RGBTORGB_COEF3 0x2180
#define DC_OVERLAY_RGBTORGB_COEF4 0x21C0

#define DC_CURSOR_CONFIG 0x1468
#define DC_CURSOR_ADDRESS 0x146C
#define DC_CURSOR_LOCATION 0x1470
#define DC_CURSOR_BACKGROUND 0x1474
#define DC_CURSOR_FOREGROUND 0x1478
#define DC_CURSOR_CLK_GATING 0x1484
#define DC_CURSOR_CONFIG_EX 0x24E8
#define DC_CURSOR_OFFSET 0x1080

#define DC_DISPLAY_DITHER_CONFIG 0x1410
#define DC_DISPLAY_PANEL_CONFIG 0x1418
#define DC_DISPLAY_PANEL_CONFIG_EX 0x2518
#define DC_DISPLAY_DITHER_TABLE_LOW 0x1420
#define DC_DISPLAY_DITHER_TABLE_HIGH 0x1428
#define DC_DISPLAY_H 0x1430
#define DC_DISPLAY_H_SYNC 0x1438
#define DC_DISPLAY_V 0x1440
#define DC_DISPLAY_V_SYNC 0x1448
#define DC_DISPLAY_CURRENT_LOCATION 0x1450
#define DC_DISPLAY_GAMMA_INDEX 0x1458
#define DC_DISPLAY_GAMMA_DATA 0x1460
#define DC_DISPLAY_INT 0x147C
#define DC_DISPLAY_INT_ENABLE 0x1480
#define DC_DISPLAY_DBI_CONFIG 0x1488
#define DC_DISPLAY_GENERAL_CONFIG 0x14B0
#define DC_DISPLAY_DPI_CONFIG 0x14B8
#define DC_DISPLAY_PANEL_START 0x1CCC
#define DC_DISPLAY_DEBUG_COUNTER_SELECT 0x14D0
#define DC_DISPLAY_DEBUG_COUNTER_VALUE 0x14D8
#define DC_DISPLAY_DP_CONFIG 0x1CD0
#define DC_DISPLAY_3DLUT_INDEX 0x1CD8
#define DC_DISPLAY_3DLUT_DATA 0x1CE0
#define DC_DISPLAY_3DLUT_SCALE 0x24B8
#define DC_DISPLAY_3DLUT_OFFSET 0x24C0
#define DC_DISPLAY_3DLUT_OFFSET_EX 0x24C8
#define DC_DISPLAY_3DLUT_ENLARGE_DATA 0x24D0
#define DC_DISPLAY_GAMMA_EX_INDEX 0x1CF0
#define DC_DISPLAY_GAMMA_EX_DATA 0x1CF8
#define DC_DISPLAY_GAMMA_EX_ONE_DATA 0x1D80
#define DC_DISPLAY_RGBTOYUV_COEF0 0x1E48
#define DC_DISPLAY_RGBTOYUV_COEF1 0x1E50
#define DC_DISPLAY_RGBTOYUV_COEF2 0x1E58
#define DC_DISPLAY_RGBTOYUV_COEF3 0x1E60
#define DC_DISPLAY_RGBTOYUV_COEF4 0x1E68
#define DC_DISPLAY_RGBTOYUV_COEFD0 0x1E70
#define DC_DISPLAY_RGBTOYUV_COEFD1 0x1E78
#define DC_DISPLAY_RGBTOYUV_COEFD2 0x1E80

#define DC_CLK_GATTING 0x1A28
#define DC_QOS_CONFIG 0x1A38

#define DC_TRANSPARENCY_OPAQUE 0x00
#define DC_TRANSPARENCY_KEY 0x02
#define DC_DISPLAY_DITHERTABLE_LOW 0x7B48F3C0
#define DC_DISPLAY_DITHERTABLE_HIGH 0x596AD1E2
#define DC_DISPLAY_3DLUT_SCALE_DATA 0x10040100

#define GAMMA_SIZE 256
#define GAMMA_EX_SIZE 300
#define DEGAMMA_SIZE 260
#define LUT3D_COMMON_SIZE 17

#define RGB_TO_RGB_TABLE_SIZE 9
#define YUV_TO_RGB_TABLE_SIZE 16
#define RGB_TO_YUV_TABLE_SIZE 12

#ifdef CONFIG_VERISILICON_MMU
#define DC_MMU_PREFETCH 0x1E98

#define MMU_REG_BASE 0x0180
#define MMU_REG_RANGE 0x700

#define MMU_REG_CONFIG 0x0184
#define MMU_REG_CONTROL 0x0388
#define MMU_REG_TABLE_ARRAY_SIZE 0x0394
#define MMU_REG_SAFE_NON_SECURE 0x0398
#define MMU_REG_SAFE_SECURE 0x039C
#define MMU_REG_SAFE_EXT_ADDRESS 0x03A0
#define MMU_REG_CONTEXT_PD 0x03B4

#define DEC_REG_CONTROL 0x0800
#define DEC_REG_CONTROL_VALUE 0x02010188

#define SE_MMU_REG_BASE 0x10000
#define SE_MMU_REG_RANGE 0x60

#define SE_MMU_REG_CONFIG 0x10010
#define SE_MMU_REG_CONTROL 0x10024
#define SE_MMU_REG_TABLE_ARRAY_SIZE 0x10030
#define SE_MMU_REG_SAFE_NON_SECUR 0x10034
#define SE_MMU_REG_SAFE_SECURE 0x10038
#define SE_MMU_REG_SAFE_EXT_ADDRESS 0x1003C
#define SE_MMU_REG_CONTEXT_PD 0x10040
#define SE_MMU_REG_INTR_ENBL 0x10044
#endif

union aq_intr_acknowledge {
	struct {
		uint32_t dc_panel_0_intr : 1;
		uint32_t dc_panel_1_intr : 1;
		uint32_t secure_reset_done_intr : 1;
		uint32_t video_0_non_secure_config_confilct : 1;
		uint32_t video_1_non_secure_config_confilct : 1;
		uint32_t overlay_0_non_secure_config_confilct : 1;
		uint32_t overlay_1_non_secure_config_confilct : 1;
		uint32_t overlay_2_non_secure_config_confilct : 1;
		uint32_t overlay_3_non_secure_config_confilct : 1;
		uint32_t cursor_0_non_secure_config_confilct : 1;
		uint32_t cursor_1_non_secure_config_confilct : 1;
		uint32_t dc_panel_0_data_underflow : 1;
		uint32_t dc_panel_1_data_underflow : 1;
		uint32_t reserved : 17;
		uint32_t axi_bus_1_error : 1;
		uint32_t axi_bus_0_error : 1;
	} bitfiles;
	uint32_t value;
};

union aq_intr_enbl {
	struct {
		uint32_t dc_panel_0_intr : 1;
		uint32_t dc_panel_1_intr : 1;
		uint32_t secure_reset_done_intr : 1;
		uint32_t video_0_non_secure_config_confilct : 1;
		uint32_t video_1_non_secure_config_confilct : 1;
		uint32_t overlay_0_non_secure_config_confilct : 1;
		uint32_t overlay_1_non_secure_config_confilct : 1;
		uint32_t overlay_2_non_secure_config_confilct : 1;
		uint32_t overlay_3_non_secure_config_confilct : 1;
		uint32_t cursor_0_non_secure_config_confilct : 1;
		uint32_t cursor_1_non_secure_config_confilct : 1;
		uint32_t dc_panel_0_data_underflow : 1;
		uint32_t dc_panel_1_data_underflow : 1;
		uint32_t reserved : 17;
		uint32_t axi_bus_1_error : 1;
		uint32_t axi_bus_0_error : 1;
	} bitfiles;
	uint32_t value;
};

enum dc8200_chip_rev {
	DC_REV_0, /* For HW_REV_5720;
                  * HW_REV_5721_311 */
	DC_REV_1, /* For HW_REV_5721_30B */
	DC_REV_2, /* For HW_REV_5721_310 */
};

enum dc8200_plane_id {
	PRIMARY_PLANE_0,
	OVERLAY_PLANE_0,
	OVERLAY_PLANE_1,
	PRIMARY_PLANE_1,
	OVERLAY_PLANE_2,
	OVERLAY_PLANE_3,
	CURSOR_PLANE_0,
	CURSOR_PLANE_1,
	PLANE_NUM
};

enum dc8200_panel_id {
	DC8200_PANEL_0,
	DC8200_PANEL_1,
	DC8200_PANEL_NUM,
};

struct dc8200_plane_reg {
	u32 y_address;
	u32 u_address;
	u32 v_address;
	u32 y_stride;
	u32 u_stride;
	u32 v_stride;
	u32 size;
	u32 top_left;
	u32 bottom_right;
	u32 scale_factor_x;
	u32 scale_factor_y;
	u32 h_filter_coef_index;
	u32 h_filter_coef_data;
	u32 v_filter_coef_index;
	u32 v_filter_coef_data;
	u32 init_offset;
	u32 color_key;
	u32 color_key_high;
	u32 clear_value;
	u32 color_table_index;
	u32 color_table_data;
	u32 scale_config;
	u32 water_mark;
	u32 degamma_index;
	u32 degamma_data;
	u32 degamma_ex_data;
	u32 src_global_color;
	u32 dst_global_color;
	u32 blend_config;
	u32 roi_origin;
	u32 roi_size;
	u32 YUVToRGBCoef0;
	u32 YUVToRGBCoef1;
	u32 YUVToRGBCoef2;
	u32 YUVToRGBCoef3;
	u32 YUVToRGBCoef4;
	u32 YUVToRGBCoefD0;
	u32 YUVToRGBCoefD1;
	u32 YUVToRGBCoefD2;
	u32 YClampBound;
	u32 UVClampBound;
	u32 RGBToRGBCoef0;
	u32 RGBToRGBCoef1;
	u32 RGBToRGBCoef2;
	u32 RGBToRGBCoef3;
	u32 RGBToRGBCoef4;
};

struct dc8200_mmu_reg {
	u32 mmu_config;
	u32 mmu_control;
	u32 table_array_size;
	u32 safe_non_secure;
	u32 safe_secure;
	u32 safe_ex;
	u32 context_pd_entry;
};

struct dc8200_fb {
	struct dc_fb data;
	bool dirty;
};

struct dc8200_scale {
	struct dc_scale data;
	bool dirty;
};

struct dc8200_position {
	struct dc_position data;
	bool dirty;
};
#if (LINUX_VERSION_CODE >= KERNEL_VERSION(4, 20, 0))
struct dc8200_blend {
	struct dc_blend data;
	bool dirty;
};
#endif

struct dc8200_colorkey {
	u32 colorkey;
	u32 colorkey_high;
	u8 transparency;
	bool dirty;
};

struct dc8200_roi {
	struct dc_roi data;
	bool dirty;
};

struct dc8200_cursor {
	struct dm_plane base;
	enum dc8200_plane_id hw_id;
	struct dc_cursor data;
	bool dirty;
};
static inline struct dc8200_cursor *to_dc8200_cursor(struct dm_plane *dm_plane)
{
	return container_of(dm_plane, struct dc8200_cursor, base);
}

struct dc8200_gamma {
	u16 gamma[GAMMA_EX_SIZE][3];
	struct mutex gamma_mutex;
	bool enable;
	bool dirty;
};

struct dc8200_degamma {
	u16 degamma[DEGAMMA_SIZE][3];
	u32 mode;
	bool dirty;
};

struct dc8200_plane {
	struct dm_plane base;
	enum dc8200_plane_id hw_id;
	struct dc8200_fb fb;
	struct dc8200_position pos;
	struct dc8200_scale scale;
	#if (LINUX_VERSION_CODE >= KERNEL_VERSION(4, 20, 0))
	struct dc8200_blend blend;
	#endif
	struct dc8200_roi roi;
	struct dc8200_colorkey colorkey;
	struct dc8200_degamma degamma;
};

static inline struct dc8200_plane *to_dc8200_plane(struct dm_plane *dm_plane)
{
	return container_of(dm_plane, struct dc8200_plane, base);
}

struct dc8200_qos {
	struct dc_qos data;
	bool dirty;
};

struct dc8200_crtc_state {
	struct dm_crtc_state base;
	u32 sync_mode;
	u32 bg_color;
	u8 mmu_prefetch;
	u8 bpp;
	bool sync_enable;
	bool dither_enable;
	bool underflow;
};

static inline struct dc8200_crtc_state *to_dc8200_crtc_state(struct dm_crtc_state *state)
{
	return container_of(state, struct dc8200_crtc_state, base);
}

struct dc8200_crtc {
	struct dm_crtc base;
	u32 max_bpc;
	u32 color_formats; /* supported color format */
	struct drm_property *sync_mode;
	struct drm_property *mmu_prefetch;
	struct drm_property *bg_color;
	struct drm_property *panel_sync;
	struct drm_property *dither;
};

static inline struct dc8200_crtc *to_dc8200_crtc(struct dm_crtc *crtc)
{
	return container_of(crtc, struct dc8200_crtc, base);
}

struct dc8200_plane_info {
	const char *name;
	u8 id;
	enum drm_plane_type type;
	unsigned int num_formats;
	const u32 *formats;
	u8 num_modifiers;
	const u64 *modifiers;
	unsigned int min_width;
	unsigned int min_height;
	unsigned int max_width;
	unsigned int max_height;
	unsigned int rotation;
	#if (LINUX_VERSION_CODE >= KERNEL_VERSION(4, 20, 0))
	unsigned int blend_mode;
	#endif
	unsigned int color_encoding;

	/* 0 means no de-gamma LUT */
	unsigned int degamma_size;

	int min_scale; /* 16.16 fixed point */
	int max_scale; /* 16.16 fixed point */

	u8 zpos; /* default zorder value,
                * and 255 means unsupported zorder capability */

	bool watermark;
	bool color_mgmt;
	bool roi;
};

struct dc8200_dc_info {
	const char *name;

	u8 panel_num;

	/* planes */
	u8 plane_num;
	const struct dc8200_plane_info *planes;

	u8 layer_num;
	unsigned int max_bpc;
	unsigned int color_formats;

	/* 0 means no gamma LUT */
	u16 gamma_size;
	u8 gamma_bits;

	u16 pitch_alignment;

	bool pipe_sync;
	bool mmu_prefetch;
	bool background;
	bool panel_sync;
	bool cap_dec;
};

#define DC_LAYER_NUM    6
#define DC_DISPLAY_NUM  2
#define DC_CURSOR_NUM   2

struct dc8200_dc {
	struct dm_dc base;
	enum dc8200_chip_rev rev;
	enum dc_out out[DC_DISPLAY_NUM];
	struct mutex cursor_mtx;
	struct dc_display display[DC_DISPLAY_NUM];
	struct dc8200_gamma gamma[DC_DISPLAY_NUM];
	struct dc8200_plane plane[DC_LAYER_NUM];
	struct dc8200_cursor cursor[DC_CURSOR_NUM];
	struct dc8200_qos qos;
	struct dc8200_dc_info *info;
	struct dec400l dec400l;
};

static inline struct dc8200_dc *to_dc8200_dc(struct dm_dc *dc)
{
	return container_of(dc, struct dc8200_dc, base);
}

void dc8200_hw_rpm_update(struct dc8200_dc *hw);
void check_and_handle_underflow(struct dm_dc *dc);
#endif /* __DC_8200_H__ */
