/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __DM_DEC_H__
#define __DM_DEC_H__

#define STREAM_COUNT       3
#define STREAM_TOTAL       32

#define DEC_PLANE_MAX      3

enum dec_align_mode {
	DEC_ALIGN_32 = 0x02,
	DEC_ALIGN_64,
};

enum dec_format {
	DEC_FORMAT_ARGB8,
	DEC_FORMAT_XRGB8,
	DEC_FORMAT_AYUV,
	DEC_FORMAT_UYVY,
	DEC_FORMAT_YUY2,
	DEC_FORMAT_YUV_ONLY,
	DEC_FORMAT_UV_MIX,
	DEC_FORMAT_ARGB4,
	DEC_FORMAT_XRGB4,
	DEC_FORMAT_A1RGB5,
	DEC_FORMAT_X1RGB5,
	DEC_FORMAT_R5G6B5,
	DEC_FORMAT_A2R10G10B10 = 0x0F,
	DEC_FORMAT_BAYER,
	DEC_FORMAT_COEFFICIENT = 0x12,
	DEC_FORMAT_ARGB16,
	DEC_FORMAT_X2RGB10 = 0x15,
};

enum dec_depth {
	DEC_DEPTH_8,
	DEC_DEPTH_10,
	DEC_DEPTH_12,
	DEC_DEPTH_14,
	DEC_DEPTH_16,
};

struct dec_stream {
	u32 main_base_addr;
	u32 aligned_stride;
	u32 ts_base_addr;
	u8 tile_mode;
	u8 align_mode;
	u8 format;
	u8 depth;
	bool dirty;
};

struct dec_fb {
	struct drm_framebuffer *fb;
	u32 addr[DEC_PLANE_MAX];
	u32 stride[DEC_PLANE_MAX];
};

#endif /* __DM_DEC_H__ */