/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */

#include "debug_print.h"
#include "vdma_hal.h"

#define DEBUG_PRINT_STA_FLAG 0x5f415453	// "STA_"
#define DEBUG_PRINT_STO_FLAG 0x5f4f5453	// "STO_"

char TEST_BUF[200];

void DBG_Printf_Exectb(const char *format, ...)
{
#if 0
	va_list list;
	uint32_t i, len;

	va_start(list, format);
	len = __vsnprintf(TEST_BUF, 200, format, list);
	va_end(list);

	for (i = 0; i < len; ++i) {
		EXECTB_WriteChar(TEST_BUF[i]);
	}
#endif
}

void DBG_Printf_Scratch(const char *format, ...)
{
#if 0
	va_list list;
	uint32_t i, len;

	va_start(list, format);
	len = __vsnprintf(TEST_BUF, 200, format, list);
	va_end(list);

	VDMA_HAL_COM_WrScratchReg(VDMA_BASE_ADDR, DEBUG_PRINT_STA_FLAG);
	for (i = 0; i < len; ++i) {
		VDMA_HAL_COM_WrScratchReg(VDMA_BASE_ADDR, TEST_BUF[i]);
	}
	VDMA_HAL_COM_WrScratchReg(VDMA_BASE_ADDR, DEBUG_PRINT_STO_FLAG);
#endif
}

void DBG_WritePostcode(uint32_t Postcode)
{
	VDMA_HAL_COM_WrScratchReg(VDMA_BASE_ADDR, Postcode);
}

#define UART_DC_TXFifoCnt       0
#define UART_DC_TXFifoCntMask   0x7F


void DBG_Printf_Uart0(const char *format, ...)
{
#if 0
	va_list list;
	uint32_t i, len;

	va_start(list, format);
	len = __vsnprintf(TEST_BUF, 200, format, list);
	va_end(list);

	for (i = 0; i < len; ++i) {
		WriteToUart(TEST_BUF[i]);
	}
#endif
}
