/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */

#ifndef _PRINTF_H_
#define _PRINTF_H_
#if (LINUX_VERSION_CODE < KERNEL_VERSION(5, 16, 0))
#include <stdarg.h>
#include <stddef.h>
#else
#include <linux/stdarg.h>
#include <linux/stddef.h>
#endif


#ifdef __cplusplus
extern "C" {
#endif


//add by songshikun, printf config
#define PRINTF_DISABLE_SUPPORT_FLOAT
#define PRINTF_DISABLE_SUPPORT_EXPONENTIAL
//#define PRINTF_DISABLE_SUPPORT_LONG_LONG
#define PRINTF_DISABLE_SUPPORT_PTRDIFF_T


/**
 * Tiny printf implementation
 * You have to implement _putchar if you use printf()
 * To avoid conflicts with the regular printf() API it is overridden by macro defines
 * and internal underscore-appended functions like printf_() are used
 * \param format A string that specifies the format of the output
 * \return The number of characters that are written into the array, not counting the terminating null character
 */

int __vsnprintf(char* buffer, const size_t maxlen, const char* format, va_list va);

#ifdef __cplusplus
}
#endif


#endif  // _PRINTF_H_
