/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#include <linux/debugfs.h>
#include "xdx_dma_dbglevel.h"
#include "rgxdevice.h"

static u32 dbglevel = 1;


void xdx_vdma_print_regs(PVRSRV_DEVICE_NODE *psDevNode)
{
	if(psDevNode)
	{
		struct dma_chan *dmc = (struct dma_chan*)(psDevNode->hDmaTxChan);
		struct dma_device *sdv = dmc->device;
		struct xdx_dma_dev *sdev = to_xdx_dma_dev(sdv);
		if(sdev && sdev->ops && sdev->ops->print_reg) {
			sdev->ops->print_reg(sdev);
		} else {
			pr_err("The func is not implemented\n");
		}
	}
}

uint32_t xdx_get_vdma_dbglevel(void)
{
	return dbglevel;
}

void xdx_set_vdma_dbglevel(uint32_t value)
{
	dbglevel = value;
}

void xdx_vdma_dbglevel_init(void)
{
	dbglevel = 1;
}

