/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __XDX_SMMU_PLATFORM_H_
#define __XDX_SMMU_PLATFORM_H_
#include "img_defs.h"
#include "pvrsrv_error.h"
#include "pmr.h"
#include "xdx_smmu_drv.h"
#include "smmu_common.h"

void xdx_smmu_cleanup_smmu_env(struct xdx_smmu_s *xsmmu);

int xdx_smmu_free_phys_mem(struct smmu_context_s *smmu_ctx,
		struct smmu_mem_desc_s *psMemDesc);

int xdx_smmu_alloc_phys_mem(struct smmu_context_s *smmu_ctx,
			struct smmu_mem_desc_s *psMemDesc,
			size_t uiBytes, size_t uiAlignment);

int xdx_smmu_phypage_clean(struct smmu_context_s *smmu_ctx,
		struct smmu_mem_desc_s *sMemDesc,
		const struct smmu_pxe_config_s *pxe_cfg,
		IMG_UINT32 uiOffset, IMG_UINT32 uiLength);
int xdx_smmu_copy_pxe_entry(void *page_entry, void *entry_data, int size);
void XDXSMMUFreeAndUnMap(PMR *psPMR);
PVRSRV_ERROR XdxSMMUComAllocAndMap(
			struct xdx_device *xdev,
			PMR *psPMR, IMG_UINT64 *u64SMMUVAddr);
PVRSRV_ERROR XdxSMMUAllocAndMap(
			struct smmu_context_s *smmu_ctx,
			PMR *psPMR, IMG_UINT64 *u64SMMUVAddr);
PVRSRV_ERROR XdxSMMUAllocAndMapGsid(
			struct xdx_device *xdev, IMG_UINT32 Gsid,
			PMR *psPMR, IMG_UINT64 *u64SMMUVAddr);
int xdx_smmu_plat_env_init(struct xdx_device *xdev, struct xdx_smmu_s *xsmmu);
int xdx_smmu_ctx_unmap_all(struct smmu_context_s *smmu_ctx);
int xdx_smmu_ctx_env_init(struct xdx_device *xdev, struct smmu_context_s *smmu_ctx,
		IMG_UINT64 Vaddr_base, IMG_UINT64 Vaddr_size);
int xdx_smmu_ctx_env_destroy(struct smmu_context_s *smmu_ctx);
int xdx_smmu_plat_env_deinit(struct xdx_device *xdev, struct xdx_smmu_s *xsmmu);

int xdx_smmu_plat_env_init(struct xdx_device *xdev, struct xdx_smmu_s *xsmmu);
int xdx_smmu_plat_env_deinit(struct xdx_device *xdev, struct xdx_smmu_s *xsmmu);

#endif
