/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __EVENT_LOG_ID_H__
#define __EVENT_LOG_ID_H__

#define EVENT_LOG_ID_ACPU_INIT_TIME            0
#define EVENT_LOG_ID_XDMA_GET_TAG              1
#define EVENT_LOG_ID_XDMA_RELEASE_TAG          2
#define EVENT_LOG_ID_DDKMEMSET                 3
#define EVENT_LOG_ID_DDKACPUMEMREG             4
#define EVENT_LOG_ID_DDKACPUMEMSET             5
#define EVENT_LOG_ID_DDKACPUMEMCOPY            6
#define EVENT_LOG_ID_VDMA0_GET_TAG             7
#define EVENT_LOG_ID_VDMA0_RELEASE_TAG         8
#define EVENT_LOG_ID_ACPU_FW_LOAD_TIME         9
#define EVENT_LOG_ID_TOTAL_FW_LOAD_TIME        10
#define EVENT_LOG_ID_ACPU_MAIN_THREAD          11
#define EVENT_LOG_ID_ACPU_HDBA_THREAD          12
#define EVENT_LOG_ID_ACPU_KCCB_THREAD          13
#define EVENT_LOG_ID_ACPU_VCCB_THREAD          14
#define EVENT_LOG_ID_ACPU_ACCB_THREAD          15
#define EVENT_LOG_ID_ACPU_PERST_ASSERT         16
#define EVENT_LOG_ID_ACPU_PERST_DEASSERT       17
#define EVENT_LOG_ID_ACPU_DEFAULT_ISR          18
#define EVENT_LOG_ID_PCIE_HMINT0               19
#define EVENT_LOG_ID_CMCU_INIT_TIME            20
#define EVENT_LOG_ID_VDMCU0_INIT_TIME          21
#define EVENT_LOG_ID_VDMCU1_INIT_TIME          22
#define EVENT_LOG_ID_CMCU_PERST_ASSERT         23
#define EVENT_LOG_ID_CMCU_PERST_DEASSERT       24
#define EVENT_LOG_ID_ASSERT_ACCB_EVENT_BIT     25
#define EVENT_LOG_ID_ASSERT_MTS_EN             26
#define EVENT_LOG_ID_ASSERT_FWGS_SIZE_EXCEED                        27
#define EVENT_LOG_ID_ASSERT_ACPU_EVENT_GROUP0_OVERFLOW              28
#define EVENT_LOG_ID_ASSERT_ACPU_EVENT_GROUP1_OVERFLOW              29
#define EVENT_LOG_ID_ASSERT_KCCB_EVENT_BIT                          30
#define EVENT_LOG_ID_ASSERT_HDBA_XDMA_PATTERN_ERROR                 31
#define EVENT_LOG_ID_ASSERT_HDBA_XDMA_SIZE_ERROR                    32
#define EVENT_LOG_ID_ASSERT_HDBA_XDMA_ALIGN_ERROR                   33
#define EVENT_LOG_ID_ASSERT_HDBA_XDMA_JOBTYPE_ERROR                 34
#define EVENT_LOG_ID_ASSERT_HDBA_ACPU_SIZE_ERROR                    35
#define EVENT_LOG_ID_ASSERT_HDBA_ACPU_ADDR_ERROR                    36
#define EVENT_LOG_ID_ASSERT_HDBA_ACPU_JOBTYPE_ERROR                 37
#define EVENT_LOG_ID_ASSERT_GIC_INIT_TIMEOUT                        38
#define EVENT_LOG_ID_ASSERT_GIC_SPIEN_ID_INVALID                    39
#define EVENT_LOG_ID_ASSERT_GIC_SPIDIS_ID_INVALID                   40
#define EVENT_LOG_ID_ASSERT_GIC_SGIPPIEN_ID_INVALID                 41
#define EVENT_LOG_ID_ASSERT_GIC_SGIPPIDIS_ID_INVALID                42
#define EVENT_LOG_ID_ASSERT_AUDIO_RIS_INVALID                       43 
#define EVENT_LOG_ID_ASSERT_ACCB_INDEX_ERROR                        44
#define EVENT_LOG_ID_ASSERT_ACCB_PROC_STATUS_ERROR                  45
#define EVENT_LOG_ID_ASSERT_ACCB_WRAPMASK_ERROR                     46
#define EVENT_LOG_ID_ASSERT_XDMA_MEMCOPY_PARAMETER_INVALID          47
#define EVENT_LOG_ID_ASSERT_XDMA_MEMSET_PARAMETER_INVALID           48
#define EVENT_LOG_ID_ASSERT_XDMA_MEMSET_ALIGN256B_LEN_EXCEED        49
#define EVENT_LOG_ID_ASSERT_XDMA_MEMSET_ALIGN4B_LEN_EXCEED          50 
#define EVENT_LOG_ID_ASSERT_XDMA_CH0_POLLTIMEOUT                    51
#define EVENT_LOG_ID_ASSERT_XDMA_CH1_POLLTIMEOUT                    52
#define EVENT_LOG_ID_ASSERT_XDMA_CH2_POLLTIMEOUT                    53
#define EVENT_LOG_ID_ASSERT_XDMA_CH3_POLLTIMEOUT                    54
#define EVENT_LOG_ID_ASSERT_XDMA_CH0_BUSERROR                       55 
#define EVENT_LOG_ID_ASSERT_XDMA_CH1_BUSERROR                       56
#define EVENT_LOG_ID_ASSERT_XDMA_CH2_BUSERROR                       57
#define EVENT_LOG_ID_ASSERT_XDMA_CH3_BUSERROR                       58 
#define EVENT_LOG_ID_ASSERT_KCCB_DCCB_OPTMODE_INVALID               59
#define EVENT_LOG_ID_ASSERT_KCCB_DCCB_CMDTYPE_INVALID               60
#define EVENT_LOG_ID_ASSERT_KCCB_WRAPMASK_ERROR                     61
#define EVENT_LOG_ID_ASSERT_KCCB_PROC_STATUS_INVALID                62
#define EVENT_LOG_ID_ASSERT_VDMA0_MEMCOPY_PARAMETER_INVALID         63
#define EVENT_LOG_ID_ASSERT_VDMA0_MEMSET_PARAMETER_INVALID          64
#define EVENT_LOG_ID_ASSERT_VDMA0_CH0_POLLTIMEOUT                   65
#define EVENT_LOG_ID_ASSERT_VDMA0_CH1_POLLTIMEOUT                   66
#define EVENT_LOG_ID_ASSERT_VDMA0_CH2_POLLTIMEOUT                   67 
#define EVENT_LOG_ID_ASSERT_VDMA0_CH3_POLLTIMEOUT                   68
#define EVENT_LOG_ID_ASSERT_VDMA0_CH0_BUSERROR                      69
#define EVENT_LOG_ID_ASSERT_VDMA0_CH1_BUSERROR                      70
#define EVENT_LOG_ID_ASSERT_VDMA0_CH2_BUSERROR                      71
#define EVENT_LOG_ID_ASSERT_VDMA0_CH3_BUSERROR                      72
#define EVENT_LOG_ID_ASSERT_HDBA_EVENT_BIT                          73
#define EVENT_LOG_ID_ASSERT_VCCB_PROC_STATUS_ERROR                  74
#define EVENT_LOG_ID_ASSERT_VCCB_CMDTYPE_INVALID                    75
#define EVENT_LOG_ID_ASSERT_VCCB_LAST_CMDBUF_RDY_NUM_ERROR          76
#define EVENT_LOG_ID_ASSERT_VCCB_EVENT_BIT                          77 
#define EVENT_LOG_ID_ASSERT_VDMA1_MEMCOPY_PARAMETER_INVALID         78
#define EVENT_LOG_ID_ASSERT_VDMA1_MEMSET_PARAMETER_INVALID          79
#define EVENT_LOG_ID_ASSERT_VDMA1_CH0_POLLTIMEOUT                   80
#define EVENT_LOG_ID_ASSERT_VDMA1_CH1_POLLTIMEOUT                   81
#define EVENT_LOG_ID_ASSERT_VDMA1_CH2_POLLTIMEOUT                   82
#define EVENT_LOG_ID_ASSERT_VDMA1_CH3_POLLTIMEOUT                   83
#define EVENT_LOG_ID_ASSERT_VDMA1_CH0_BUSERROR                      84
#define EVENT_LOG_ID_ASSERT_VDMA1_CH1_BUSERROR                      85
#define EVENT_LOG_ID_ASSERT_VDMA1_CH2_BUSERROR                      86
#define EVENT_LOG_ID_ASSERT_VDMA1_CH3_BUSERROR                      87
#define EVENT_LOG_ID_ASSERT_CMCUDB_A2C_UNEXPECTED                   88
#define EVENT_LOG_ID_ASSERT_CMCUDB_H02C_UNEXPECTED                  89
#define EVENT_LOG_ID_ASSERT_CMCUDB_H12C_UNEXPECTED                  90
#define EVENT_LOG_ID_ASSERT_CMCU_NMI_EXCEPTION                      91
#define EVENT_LOG_ID_ASSERT_CMCU_MMFAULT_EXCEPTION                  92
#define EVENT_LOG_ID_ASSERT_CMCU_BUSFAULT_EXCEPTION                 93
#define EVENT_LOG_ID_ASSERT_CMCU_SECUREFAULT_EXCEPTION              94
#define EVENT_LOG_ID_ASSERT_CMCU_SVCALL_EXCEPTION                   95
#define EVENT_LOG_ID_ASSERT_CMCU_DEBUGMONITOR_EXCEPTION             96
#define EVENT_LOG_ID_ASSERT_CMCU_PENDSV_EXCEPTION                   97
#define EVENT_LOG_ID_ASSERT_CMCU_SYSTICK_EXCEPTION                  98
#define EVENT_LOG_ID_ASSERT_CMCU_AHB_C2DTIMEOUT                     99
#define EVENT_LOG_ID_ASSERT_CMCU_AHB_APB0TIMEOUT                    100
#define EVENT_LOG_ID_ASSERT_CMCU_AHB_APB1TIMEOUT                    101
#define EVENT_LOG_ID_ASSERT_CMCU_THERMAL_OVER_FATAL                 102
#define EVENT_LOG_ID_ASSERT_MEMCOPYU64_PARAMETER_INVALID            103
#define EVENT_LOG_ID_ASSERT_MEMCOPYU32_PARAMETER_INVALID            104
#define EVENT_LOG_ID_ASSERT_MEMSETU64_PARAMETER_INVALID             105
#define EVENT_LOG_ID_ASSERT_MEMSETU32_PARAMETER_INVALID             106
#define EVENT_LOG_ID_ASSERT_TBD                                     107
#define EVENT_LOG_ID_BOOTLOADER_FW_ECC_CHECK_ERROR                  108
#define EVENT_LOG_ID_BOOTLOADER_FW_SHAAES_CHECK_ERROR               109
#define EVENT_LOG_ID_ACPU_EXCEPTION                                 110
#define EVENT_LOG_ID_ACPU_UNEXPECTED_EXCEPTION                      111
#define EVENT_LOG_ID_CMCU_HARD_FAULT_SPINFO                         112
#define EVENT_LOG_ID_CMCU_HARD_FAULT_DUMP_STACK                     113
#define EVENT_LOG_ID_CMCU_UNEXPECTED_INTERRUPT                      114
#define EVENT_LOG_ID_ASSERT_POWER_STAGE_NOT_CLEAN                   115
#define EVENT_LOG_ID_WATCHDOG_ISR                                   116
#define EVENT_LOG_ID_GIC_SURPRISE_INT                               117
#define EVENT_LOG_ID_PCIE_HMINT1                                    118  
#define EVENT_LOG_ID_PCIE_POWER_STATE_CHANGE_D3HOT                  119
#define EVENT_LOG_ID_PCIE_POWER_STATE_CHANGE_D1                     120
#define EVENT_LOG_ID_PCIE_POWER_STATE_CHANGE_D0                     121 
#define EVENT_LOG_ID_CMCU_POWER_DEVICE_POWER_STATE_CHANGE           122
#define EVENT_LOG_ID_CMCU_POWER_ENTER_PS                            123
#define EVENT_LOG_ID_CMCU_POWER_ENTER_PS_FAILED                     124
#define EVENT_LOG_ID_CMCU_POWER_PS1_WFI                             125
#define EVENT_LOG_ID_CMCU_POWER_PS2_WFI                             126
#define EVENT_LOG_ID_CMCU_POWER_PSX_WAKEUP                          127
#define EVENT_LOG_ID_CMCU_POWER_D1_TO_D0                            128
#define EVENT_LOG_ID_ACPU_POWER_WFI                                 129
#define EVENT_LOG_ID_ACPU_POWER_WAKEUP                              130
#define EVENT_LOG_ID_VDMCU0_POWER_WFI                               131
#define EVENT_LOG_ID_VDMCU0_POWER_WAKEUP                            132
#define EVENT_LOG_ID_VDMCU1_POWER_WFI                               133
#define EVENT_LOG_ID_VDMCU1_POWER_WAKEUP                            134
#define EVENT_LOG_ID_CMCU_POWER_ENTER_PS_CANCEL                     135
#define EVENT_LOG_ID_GDDR_ISR                                       136
#define EVENT_LOG_ID_CMCU_HARD_FAULT_STATUS                         137
#define EVENT_LOG_ID_PCIE_HMINT2                                    138  
#define EVENT_LOG_ID_PCIE_HMINT3                                    139  
#define EVENT_LOG_ID_PCIE_HMINT4                                    140  
#define EVENT_LOG_ID_PCIE_HMINT5                                    141  
#define EVENT_LOG_ID_PCIE_HMINT6                                    142  
#define EVENT_LOG_ID_WAIT_VALUE8                                    143
#define EVENT_LOG_ID_WAIT_VALUE16                                   144
#define EVENT_LOG_ID_WAIT_VALUE32                                   145
#define EVENT_LOG_ID_WAIT_VALUE64                                   146
#define EVENT_LOG_ID_SETWAIT_VALUE8                                 147
#define EVENT_LOG_ID_SETWAIT_VALUE16                                148
#define EVENT_LOG_ID_SETWAIT_VALUE32                                149
#define EVENT_LOG_ID_SETWAIT_VALUE64                                150
#define EVENT_LOG_ID_WAIT_GREATER32                                 151
#define EVENT_LOG_ID_ACPU_WAIT_VALUE8                               152
#define EVENT_LOG_ID_ACPU_WAIT_VALUE16                              153
#define EVENT_LOG_ID_ACPU_WAIT_VALUE32                              154
#define EVENT_LOG_ID_ACPU_WAIT_VALUE64                              155
#define EVENT_LOG_ID_GIC_FIQ                                        156
#define EVENT_LOG_ID_CMCU_USAGE_FAULT                               157
#define EVENT_LOG_ID_ASSERT_VDMCU0_NMI_EXCEPTION                    158
#define EVENT_LOG_ID_ASSERT_VDMCU0_MMFAULT_EXCEPTION                159
#define EVENT_LOG_ID_ASSERT_VDMCU0_BUSFAULT_EXCEPTION               160
#define EVENT_LOG_ID_ASSERT_VDMCU0_USAGEFAULT_EXCEPTION             161
#define EVENT_LOG_ID_ASSERT_VDMCU0_SECUREFAULT_EXCEPTION            162
#define EVENT_LOG_ID_ASSERT_VDMCU0_SVCALL_EXCEPTION                 163
#define EVENT_LOG_ID_ASSERT_VDMCU0_DEBUGMONITOR_EXCEPTION           164
#define EVENT_LOG_ID_ASSERT_VDMCU0_PENDSV_EXCEPTION                 165
#define EVENT_LOG_ID_ASSERT_VDMCU0_SYSTICK_EXCEPTION                166
#define EVENT_LOG_ID_VDMCU0_HARD_FAULT_SPINFO                       167
#define EVENT_LOG_ID_VDMCU0_HARD_FAULT_DUMP_STACK                   168
#define EVENT_LOG_ID_VDMCU0_UNEXPECTED_INTERRUPT                    169
#define EVENT_LOG_ID_ASSERT_VDMCU1_NMI_EXCEPTION                    170
#define EVENT_LOG_ID_ASSERT_VDMCU1_MMFAULT_EXCEPTION                171
#define EVENT_LOG_ID_ASSERT_VDMCU1_BUSFAULT_EXCEPTION               172
#define EVENT_LOG_ID_ASSERT_VDMCU1_USAGEFAULT_EXCEPTION             173
#define EVENT_LOG_ID_ASSERT_VDMCU1_SECUREFAULT_EXCEPTION            174
#define EVENT_LOG_ID_ASSERT_VDMCU1_SVCALL_EXCEPTION                 175
#define EVENT_LOG_ID_ASSERT_VDMCU1_DEBUGMONITOR_EXCEPTION           176
#define EVENT_LOG_ID_ASSERT_VDMCU1_PENDSV_EXCEPTION                 177
#define EVENT_LOG_ID_ASSERT_VDMCU1_SYSTICK_EXCEPTION                178
#define EVENT_LOG_ID_VDMCU1_HARD_FAULT_SPINFO                       179
#define EVENT_LOG_ID_VDMCU1_HARD_FAULT_DUMP_STACK                   180
#define EVENT_LOG_ID_VDMCU1_UNEXPECTED_INTERRUPT                    181
#define EVENT_LOG_ID_VDMCU0_HARD_FAULT_STATUS                       182
#define EVENT_LOG_ID_VDMCU1_HARD_FAULT_STATUS                       183
#define EVENT_LOG_ID_ASSERT_KCCB_DCCB_MEMODE_INVALID                184
#define EVENT_LOG_ID_ASSERT_GET_VDMA_CHANNEL_INVALID                185
#define EVENT_LOG_ID_ASSERT_KCCB_WITH_SPARSE_INVALID                186
#define EVENT_LOG_ID_ASSERT_KCCB_WITHOUT_SPARSE_INVALID             187
#define EVENT_LOG_ID_ASSERT_VDMA_DESC_NULL                          188
#define EVENT_LOG_ID_ASSERT_VDMA_DESC_CFG_NULL                      189
#define EVENT_LOG_ID_ASSERT_VDMA_DESC_DATAPTR_ALIGN                 190
#define EVENT_LOG_ID_ASSERT_VDMA_DESC_LENUNIT_INVALID               191
#define EVENT_LOG_ID_ASSERT_VDMA_DESC_LINKEND_INVALID               192
#define EVENT_LOG_ID_ASSERT_VDMA_DESC_DATAPTR_ADDRMODE              193
#define EVENT_LOG_ID_ASSERT_VDMA_DESC_TRANSFERLEN_INVALID           194
#define EVENT_LOG_ID_ASSERT_VDMA_DESC_NUM_INVALID                   195
#define EVENT_LOG_ID_KCCB_VDMA_L2L_COPY_DESC_FULL                   196
#define EVENT_LOG_ID_KCCB_VDMA_L2D_COPY_DESC_FULL                   197
#define EVENT_LOG_ID_KCCB_VDMA_L2L_COPY_GET_FREE_TAG_FULL           198
#define EVENT_LOG_ID_KCCB_VDMA_L2D_COPY_GET_FREE_TAG_FULL           199
#define EVENT_LOG_ID_KCCB_VDMA_D2D_COPY_GET_FREE_TAG_FULL           200
#define EVENT_LOG_ID_ASSERT_DCCB_CMD_XFERLEN                        201
#define EVENT_LOG_ID_KCCB_VDMA_D2D_COPY                             202
#define EVENT_LOG_ID_KCCB_VDMA_L2D_COPY                             203
#define EVENT_LOG_ID_KCCB_VDMA_L2L_COPY                             204
#define EVENT_LOG_ID_KCCB_PROC_KCCB_NO_DCCB                         205
#define EVENT_LOG_ID_KCCB_PROC_KCCB_INCLUDE_DCCB                    206
#define EVENT_LOG_ID_KCCB_CHECK_SRC_DESC_CMD_IS_FULL                207
#define EVENT_LOG_ID_KCCB_CHECK_DST_DESC_CMD_IS_FULL                208
#define EVENT_LOG_ID_KCCB_VDMA0_CALLBACK                            209
#define EVENT_LOG_ID_KCCB_VDMA1_CALLBACK                            210
#define EVENT_LOG_ID_DCCB_PACKAGE_WITH_SPARSE_DIRECT_MODE           211
#define EVENT_LOG_ID_DCCB_PACKAGE_WITH_OUT_SPARSE_DIRECT_MODE       212
#define EVENT_LOG_ID_KCCB_DCCB_MEMODE                               213
#define EVENT_LOG_ID_KCCB_PROC_DCCB_START                           214
#define EVENT_LOG_ID_KCCB_PROC_DCCB_END                             215
#define EVENT_LOG_ID_KCCB_SUBMIT                                    216
#define EVENT_LOG_ID_KCCB_DCCB_GEN_VDMA_DESC_LINK_LIST              217
#define EVENT_LOG_ID_ASSERT_SGLTABLE_SIZE_ALIGN_8_BYTE              218
#define EVENT_LOG_ID_ASSERT_SGLTABLE_SIZE_ALIGN_1K_BYTE             219
#define EVENT_LOG_ID_THERMAL_STATE_CHANGE                           220
#define EVENT_LOG_ID_THERMAL_OVER_PROTECT                           221
#define EVENT_LOG_ID_THERMAL_TMT_VALUE_CHANGE                       222



#define EVENT_LOG_ID_DEBUG_HEX8                0xFFF8
#define EVENT_LOG_ID_DEBUG_HEX7                0xFFF9
#define EVENT_LOG_ID_DEBUG_HEX6                0xFFFA
#define EVENT_LOG_ID_DEBUG_HEX5                0xFFFB
#define EVENT_LOG_ID_DEBUG_HEX4                0xFFFC
#define EVENT_LOG_ID_DEBUG_HEX3                0xFFFD
#define EVENT_LOG_ID_DEBUG_HEX2                0xFFFE
#define EVENT_LOG_ID_DEBUG_HEX1                0xFFFF

#endif

