/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#pragma once

#include "SysTypes.h"

#define KCCB_SIZE                   512
#define KCCB_INDEX_MASK             (KCCB_SIZE - 1)

#define DCCB_DESC_SIZE              1024
#define DCCB_DESC_INDEX_MASK        (DCCB_DESC_SIZE - 1)

typedef enum
{
    cKCCBProcStatusNotProc = 0,
    cKCCBProcStatusDccbProc,
    cKCCBProcStatusDmaDone,
    cKCCBProcStatusNoDma,
    cKCCBProcStatusMax
}KCCBProcStatus;

typedef struct
{
    U32 dccbDescWriteOffset;
    U32 dccbDescReadOffset;
    U32 dccbDescWrapMask;
    U32 dccbDescSize;
}DCCBDescInfo;

typedef struct
{
    U32 curProcKccbIdx;
    U32 curSubmitKccbIdx;
    U32 curDccbStart;
    U32 curDccbEnd;
    U16 vdma0DescNum[4][64];
    U16 vdma1DescNum[4][64];
    U8  vdma0OpCode[4][64];
    U8  vdma1OpCode[4][64];
    U32 kccbVdmaCmdCount[KCCB_SIZE];
    U32 kccbProcStatus[KCCB_SIZE];
    U64 kccbProcPerf[KCCB_SIZE];
    U32 debugEventSet;
    U32 debugEventClr;
    U32 debugKCCBProc;
    U32 debugEventFlag;
    U64 kccbPerfTotalTimeUsed;
    U64 kccbPerfTotalCmdCount;
    U64 UpdateSrcDescWriteOffsetCount;
    U64 UpdateSrcDescReadOffsetCount;
    U64 UpdateDstDescWriteOffsetCount;
    U64 UpdateDstDescReadOffsetCount;
    U64 submitVdmaNum;
    U64 receiveVdmaNum;
    U32 MaxPackNum;
    U32 MaxSrcDescPoolBusy;
    U32 MaxDstDescPoolBusy;
    U32 vdma0MaxBusyTags;
    U32 vdma1MaxBusyTags;
    U32 kccbPerfMax;
    U32 kccbPerfMaxID;
    DCCBDescInfo srcDescInfo;
    DCCBDescInfo dstDescInfo;
}KCCBManager_T;

