/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#pragma once

#include "SysTypes.h"

#define VDMA0_CHANNEL_NUM             4
#define VDMA0_CHANNEL_TAGS_NUM        64
#define VDMA0_CHANNEL_TAGS_NUM_MASK   63

#define VDMA1_CHANNEL_NUM             4
#define VDMA1_CHANNEL_TAGS_NUM        64
#define VDMA1_CHANNEL_TAGS_NUM_MASK   63

#define VDMA_CHANNEL_NUM             4
#define VDMA_CHANNEL_TAGS_NUM        64
#define VDMA_CHANNEL_TAGS_NUM_MASK   63

typedef U64 VDMACallBack_T;

typedef enum
{
    cVDMAEventNone = 0,
    cVDMAEventTriggered
}VDMAEventStatus_T;

typedef struct
{
    __V U8 head;
    __V U8 tail;
    __V U8 freeTags;
    __V U8 busyTags;
    U8 tagsPool[VDMA_CHANNEL_TAGS_NUM] XDX_ALIGN(16);
}VDMAChannelManager_T;

typedef struct
{
    VDMAEventStatus_T vdmaEvent;
    VDMACallBack_T callBack[VDMA_CHANNEL_NUM][VDMA_CHANNEL_TAGS_NUM];
    U64 callBackParameter[VDMA_CHANNEL_NUM][VDMA_CHANNEL_TAGS_NUM];
    VDMAChannelManager_T ch[VDMA_CHANNEL_NUM];
    __V U8 cmplEvent[VDMA_CHANNEL_NUM];
    __V U8 pollToEvent[VDMA_CHANNEL_NUM];
    __V U8 busErrEvent[VDMA_CHANNEL_NUM];
}VDMAManager_T;

typedef struct
{
    U64 cmdTagMask;
}VDMAHandle_T;

typedef enum
{
    cVDMAAddrModeHostSVA = 0,
    cVDMAAddrModeHostSPA,
    cVDMAAddrModeGPUSVA,
    cVDMAAddrModeGPUSPA,
    cVDMAAddrModeMax
}VDMAAddrMode_T;

typedef union
{
    uint32_t all;
    struct
    {
        uint32_t dstAddrMode : 2; //0:PA 1:VA
        uint32_t srcAddrMode : 2; //0:PA 1:VA
        uint32_t channelAuto : 1; //0:Auto 1:using channel
        uint32_t intEn       : 1; //0:no int 1: enable int
        uint32_t channel     : 2; //
        uint32_t tag         : 6;
        uint32_t opCode      : 8;
        uint32_t is1k        : 1;
        uint32_t rev         : 9;
    };
}VDMAInfo_T;

