/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#pragma once

#include "SysTypes.h"

#define XDMA_CHANNEL_NUM             4
#define XDMA_CHANNEL_TAGS_NUM        64
#define XDMA_CHANNEL_TAGS_NUM_MASK   63

typedef U64 XDMACallBack_T;

typedef enum
{
    cXDMAEventNone = 0,
    cXDMAEventTriggered
}XDMAEventStatus_T;

typedef struct
{
    __V U8 head;
    __V U8 tail;
    __V U8 freeTags;
    __V U8 busyTags;
    U8 tagsPool[XDMA_CHANNEL_TAGS_NUM] XDX_ALIGN(16);
}XDMAChannelManager_T;

typedef struct
{
    XDMAEventStatus_T xdmaEvent;
    XDMACallBack_T callBack[XDMA_CHANNEL_NUM][XDMA_CHANNEL_TAGS_NUM];
    U64 callBackParameter[XDMA_CHANNEL_NUM][XDMA_CHANNEL_TAGS_NUM];
    XDMAChannelManager_T ch[XDMA_CHANNEL_NUM];
    __V U8 cmplEvent[XDMA_CHANNEL_NUM];
    __V U8 pollToEvent[XDMA_CHANNEL_NUM];
    __V U8 busErrEvent[XDMA_CHANNEL_NUM];
}XDMAManager_T;

