/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __XDXTHM_IRQ_H__
#define __XDXTHM_IRQ_H__

#include "xdx_shared.h"

#if defined(SUPPORT_LINUX_DVFS) && defined(CONFIG_DEVFREQ_THERMAL)
#include "pvr_dvfs.h"
#include <linux/thermal.h>
#include <linux/devfreq_cooling.h>

int RegisterThermalZoneDevice(struct device *dev,
								 IMG_DVFS_DEVICE *psDVFSDevice,
								 struct devfreq_cooling_power *powerOps);

void UnregisterThermalZoneDevice(struct device *dev, IMG_DVFS_DEVICE *psDVFSDevice);
#endif /* SUPPORT_LINUX_DVFS && CONFIG_DEVFREQ_THERMAL */

#define TEMP_HYSTERESIS 2
#define TEMP_SLOWDOWN 90
#define TEMP_SHUTDOWN 100
#define MIN_WORK_CLOCK_HZ 500000000
#define MIN_WORK_VOLT_MV 720
#define TIMEOUT_MS 1000

//#include "xdxacpu.h"
struct xdx_device;

struct xdx_thermal {
	struct xdx_device *xdev;
	struct delayed_work work;
	struct workqueue_struct *workq;
	struct xdx_ip_block base;
	bool enable_shutdown;
	int slowdown_temp;
	int hyst;
	int shutdown_temp;
	int curr_temp;
	u32 gfx_default;
	u32 volt_default;
	bool slowdown_status;
#if defined(SUPPORT_LINUX_DVFS) && defined(XDXGPU)
	bool dvfs_enabled;
#endif
};

extern const struct xdx_ip_block_version thermal_block_version;

void xdx_thermal_monitor(struct work_struct *wk);
int xdx_thm_init(struct xdx_device *xdev);
int xdx_thm_fini(struct xdx_device *xdev);


#endif /* __XDXTHM_IRQ_H__ */