/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __VPU_SMMU_H__
#define __VPU_SMMU_H__

#define PANGU_REG_VDEC_SMMU_BASE          0x08800000
#define PANGU_REG_VENC_SMMU_BASE          0x08C00000
#define PANGU_REG_VDEC_SMMU_INTERNAL_BASE          (0x20000000 + PANGU_REG_VDEC_MMU_BASE) 
#define PANGU_REG_VENC_SMMU_INTERNAL_BASE		   (0x20000000 + PANGU_REG_VENC_MMU_BASE)

struct vpu_smmu_addr {
    uint32_t handle;
    uint32_t size;
    uint64_t offset;
    uint64_t smmu_va;
};


long vpu_smmu_ioctl(unsigned int cmd, struct file *filp, unsigned long arg);
int vpu_smmu_ioctl_map(struct drm_device *ddev,void * data, struct drm_file *file);
int vpu_smmu_ioctl_unmap(struct drm_device *ddev,void * data, struct drm_file *file);
int vpu_smmu_map(struct xdx_device *xdev, struct xdx_bo *bo, unsigned long long* vaddr);
#endif /* __VPU_SMMU_H__ */