/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __XDX_ACPU_H__
#define __XDX_ACPU_H__

#include "xdx_shared.h"
#include "pangu.h"
#include "xdx_drv.h"
#include "xdxacpu.h"
#include "xdx_irq.h"

struct acpudb_pool_t;
struct xdx_acpu {
	struct xdx_ip_block base;
	struct xdx_irq_src *irq_src;
	acpudb_pool_t *acpu_db_pool;
	void __iomem *rmmio;
	resource_size_t rmmio_size;
};

/* mmio register read/write functions */
uint64_t cmcu_doorbell_readq(struct xdx_acpu *acpu, uint32_t offset);
void cmcu_doorbell_writeq(struct xdx_acpu *acpu, uint32_t offset, uint64_t v);
void acpu_doorbell_submit(struct xdx_acpu *acpu, uint32_t dbNum,
			IMG_UINT64 ui64Value);

extern const struct xdx_ip_block_version acpu_ip_block_version;
int xdx_acpu_fini(struct xdx_device *xdev);
#endif /* __XDX_ACPU_H__ */
