/*
 * @Copyright   Copyright (c) XIANGDIXIAN Computing Technology Co., Ltd. All Rights Reserved
 * @License     Dual MIT/GPLv2
 */
#ifndef __XDX_DRV_H__
#define __XDX_DRV_H__

#include <linux/firmware.h>
#include <linux/platform_device.h>
#include "output/hdmi/xdx_hdmi_drv.h"
#include "output/dp/xdx_dp_drv.h"

#define DRIVER_AUTHOR   "XDXCT Linux Driver Team"
#define DRIVER_NAME		"xdxgpu"
#define DRIVER_DESC		"XDXCT GPU"
#define DRIVER_DATE		"20220114"

#define KMS_DRIVER_MAJOR 1
#define KMS_DRIVER_MINOR 0
#define KMS_DRIVER_PATCHLEVEL 0

extern char *xdx_virtual_display;
extern int xdx_vram_limit;
extern int xdx_vis_vram_limit;
extern int xdx_msi_enable;
extern int xdx_virtual_vblank;
extern int xdx_virtual_output;
extern int xdx_fake_mode;
extern uint32_t xdx_dc_heap_size;

extern const struct file_operations xdx_drm_fops;

int PVRSRVDriverInit(void);
void PVRSRVDriverDeinit(void);

#endif /* __XDX_DRV_H__ */
